
#include <sol.h>

/* 
 * a model of the magic square problem
 */


using namespace std;

int main(int argc, char *argv[])
{  
  int i, j, k, N = ( argc > 1 ? atoi(argv[1]) : 11 );


  cout << endl << "\tCostas Array (order " 
       << N << ")" << endl << endl;

  // create the csp
  CSP model;

  VarArray X( N, 1, N /*, Variable::COMP*/ );

  //  model.add( X );

  VarArray differences[N-2];


  model.add( AllDifferent( X ) );
  
  for(i=1; i<N-1; ++i) {
    for(j=0; j<N-1; ++j) 
      if( i+j < N ) {
	differences[i-1].add( (X[j] - X[i+j]) );
// 	if( j ) 
// 	  for( k=j-1; k>=0; --k )
// 	    model.add( (differences[i-1][k] != differences[i-1][j]) );
      }
    model.add( AllDifferent( differences[i-1] ) );
  }
  

  for(i=0; i<N-2; ++i) 
    for(j=0; j<(differences[i].size()); ++j) 
      model.add( differences[i][j] != 0 );


  //  cout << model << endl;


  ImpactOverWDeg heuristic;
  Solver s(model, heuristic);

//   s.print( cout );
//   cout << endl;


  model.printXML( cerr );

  s.solve();
  cout << endl << endl;    
  for(i=0; i<N; ++i)
    cout << setw(3) << X[i].value() ;
  cout << endl ;
  for(i=0; i<N-2; ++i) {
    for(j=0; j<(differences[i].size()); ++j) {
      cout << setw(3) << differences[i][j].value() ;
    }
    cout << endl;
  }
  cout << setw(3) << (X[0].value() - X[N-1].value()) << endl << endl;

  s.printStatistics(std::cout);
  cout<<endl<<endl;
}




