
#include <sol.h>
#include <gen.h>

using namespace std;


int main(int argc, char *argv[])
{  

  long Seed;
  int ins, Var, Dom, Con, Ari, Nne;

  Seed = ( argc > 2 ? (long)(-1 * atoi(argv[2])) : -11041979 );
  ins  = ( argc > 1 ? atoi(argv[1]) : 5    );
  Var  = ( argc > 3 ? atoi(argv[3]) : 100  );
  Dom  = ( argc > 4 ? atoi(argv[4]) : 2    );
  Con  = ( argc > 5 ? atoi(argv[5]) : 450 );
  Ari  = ( argc > 6 ? atoi(argv[6]) : 3    );

  SATGenerator gen(Seed, Var, Dom, Con, Ari);
  
  cout<<endl<<"\t"<<ins<<" Random Problem(s)"
      <<"\n\t\t["<<Var<<" variables, "<<Dom<<" values, "
      <<Con<<" "<<" nogoods]"<<endl<<endl;


  for(int inst=0; inst<ins; inst++) {

    CSP model;
    VarArray X(Var, 0, Dom-1);
    VarArray scope(Ari);


    while( gen.erateClause() ) {
      for(int i=0; i<Ari; ++i) 
	scope[i] = X[gen.vars[i]];
      Clause con( scope, gen.vals );
      model.add( con );
    }
    

    MinDomain heuristic;
    Solver s(model, heuristic);

    if( s.solve() == Solver::SAT) {
      //  	for(int k=0; k<Var; ++k)
      //  	  cout << " " << X[k]->val ;
      //  	cout << endl;
    }
    s.printStatistics(cout);
    cout << endl;
    gen._c = 0;
  }
  
  cout << endl;
}





   
// //     int sumarity = 0;
// //     int nbsum = 0;
// //     srand( Seed );
// //     int varidx[Var];
// //     for(int i=0; i<Var; ++i)
// //       varidx[i] = i;
// //     for(int i=0; i<nbsum; ++i) {
// //       for(int j=0; j<sumarity; ++j) { 
// // 	//cout << (j + (rand() % (Var-j))) << " ";
// // 	int idx = (j + (rand() % (Var-j)));
// // 	int aux = varidx[idx];
// // 	varidx[idx] = varidx[j];
// // 	varidx[j] = aux;
// // 	scope[j] = X[aux];
// //       }
// //       //cout << endl;
// // 	//	scope[j] = X[j + (int)(((double)((Var-j) * rand())) 
// // 	//				     / (double)RAND_MAX) ];
// //       Sum *thesum = new Sum( scope, sumarity, 5*sumarity, 5*sumarity );
// //       model.post( thesum );
// //       //      thesum->post( trg );
// //       //model.add( (IntVar*)(thesum) );
// //     }



